unit U_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Spin, StdCtrls, U_Queue;

type
  TStringElement = class
    inhalt: string;
  end;
  TIntegerElement = class
    inhalt: integer;
  end;
  TBooleanElement = class
    inhalt: boolean;
  end;


  TForm1 = class(TForm)
    B_Enq_String: TButton;
    B_Enq_Integer: TButton;
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    Edit2: TEdit;
    B_Front: TButton;
    B_Dequeue: TButton;
    CheckBox1: TCheckBox;
    B_Enq_Boolean: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure B_Enq_StringClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure B_Enq_IntegerClick(Sender: TObject);
    procedure B_DequeueClick(Sender: TObject);
    procedure B_FrontClick(Sender: TObject);
    procedure B_Enq_BooleanClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    queue: TQueue;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


{ **** Routinen fr Oberflche **** }

procedure TForm1.B_Enq_StringClick(Sender: TObject); { String einfgen         }
var i: TStringElement;
begin
  i:= TStringElement.create;                          { neues Element erzeugen }
  i.inhalt:= Edit1.Text;
  queue.enqueue(i);                                   { und einfgen           }
end;

procedure TForm1.B_Enq_IntegerClick(Sender: TObject); { Integer einfgen       }
var i: TIntegerElement;
begin
  i:= TIntegerElement.create;                         { neues Element erzeugen }
  i.inhalt:= spinedit1.value;
  queue.enqueue(i);                                   { und einfgen           }
end;

procedure TForm1.B_Enq_BooleanClick(Sender: TObject);
var i: TBooleanElement;
begin
  i:= TBooleanElement.create;                         { neues Element erzeugen }
  i.inhalt:= checkbox1.checked;
  queue.enqueue(i);                                   { und einfgen           }
end;

procedure TForm1.B_DequeueClick(Sender: TObject);
begin
  queue.dequeue;                                { Element aus Schlange lschen }
end;

procedure TForm1.B_FrontClick(Sender: TObject);
{ in dieser Prozedur werden die beiden Mglichkeiten der Typerkennung genutzt: }
{   a)  (stack.top as TIntegerElement).Inhalt                                  }
{   b)  TBooleanElement(stack.top).Inhalt                                      }
{ beide Alternativen sind ok, allerdings bietet sich die ..as..-Methode gerade }
{ fr die Verwendung einer WITH-Anweisung an:                                  }
{    with e as TIntElement do                                                  }
{    begin                                                                     }
{      Inhalt:= 5;                                                             }
{      ...                                                                     }
{    end;                                                                      }
{ dies aber nur nebenbei.........................                              }
begin
  if not queue.isEmpty
  then begin
         if (queue.front is TIntegerElement)     { ist Element ein IntElement? }
           then edit2.text:= IntToStr((queue.front as TIntegerelement).inhalt);
         if (queue.front is TStringElement)      { oder ein StringElement?     }
           then edit2.text:= (queue.front as TStringElement).inhalt;
         if (queue.front is TBooleanElement)     { oder ein BoolElement?       }
           then if TBooleanElement(queue.front).inhalt
                  then edit2.text:= 'true'
                  else edit2.text:= 'false';;
       end
  else edit2.text:= 'Queue ist leer...';
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  queue:= TQueue.create;              { Schlange kreieren und initialisieren   }
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Queue.Free;                            { Queue und dessen Elemente freigeben }
end;


end.
